#!/usr/bin/python

import os,sys

diseaseNames = ["T2D","AMD","T1D","MI"]
fUnits = [0.2, 0.5, 0.5, 0.2]
yticUnits = [0.05, 0.05, 0.05, 0.05]

drst = "results"
dtmp = "tmp"
iprefix = "CTE.a"
oprefix = "CTE.a"

AUC_eORs = []
AUC_lowers = []
AUC_uppers = []
AUC_means = []
AUC_ses = []
prevals = []
ymaxes = []

for i in range(len(diseaseNames)):
    fAUC = open("%s/%s.%s.auc" % (drst,iprefix,diseaseNames[i]))
    AUC_eORs.append(float(fAUC.readline().split()[1]))
    AUC_lowers.append(float(fAUC.readline().split()[1]))
    AUC_uppers.append(float(fAUC.readline().split()[1]))
    AUC_means.append(float(fAUC.readline().split()[1]))
    AUC_ses.append(float(fAUC.readline().split()[1]))
    prevals.append(float(fAUC.readline().split()[1]))
    fAUC.close()

    fHist = open("%s/%s.%s.whist" % (drst,iprefix,diseaseNames[i]))
    breaks = []
    ymax = 0
    fHist.readline()
    nBreak = 0
    for line in fHist:
        c = line.split()
        if len(breaks) == 0:
            breaks.append(c[0])
        breaks.append(c[1])
        if ymax < float(c[3]):
            ymax = float(c[3])
        if ymax < float(c[4]):
            ymax = float(c[4])
        nBreak += 1
    fHist.close()
    ymax = ymax * 1.1
    ymaxes.append(ymax)

fCMD = open("%s/%s_whist.cmd" % (dtmp,oprefix),'w')
fCMD.write("set terminal postscript eps enhanced color linewidth 1.0 size 3.6,3.6 font 'Calibri,12' fontfile 'calibri.pfb' fontfile 'GillSansMT.pfb'\n")
fCMD.write("set out '%s/%s_whist.eps'\n" % (drst,oprefix))
fCMD.write("set multiplot layout 2,2\n")
fCMD.write("set object 1 rect from graph 0, graph 0 to graph 1, graph 1 behind\n");
fCMD.write("set object 1 rect fc rgb '#DDDDDD' fillstyle solid 1.0\n");
fCMD.write("set key below width -3 samplen 2 box\n")
#fCMD.write("set xlabel 'Genetic Risk Score : {/Symbol g}(x) = {/Symbol S}_i x_i log_{10}(OR_i)'\n")
fCMD.write("set xlabel 'Genetic Risk Score : {/Symbol g}(x)'\n")
fCMD.write("set ylabel 'Fraction of individuals' offset 1\n")
fCMD.write("set style fill solid border -1\n")
fCMD.write("set grid x y\n");
for i in range(len(diseaseNames)):
    fCMD.write("set yrange [%f:%f]\n" % (0-ymaxes[i],ymaxes[i]))
    fCMD.write("set xtics nomirror out\n")
    fCMD.write("set ytics nomirror out ('0.00' 0")
    fytic = yticUnits[i]
    while( fytic < ymaxes[i] ):
        fCMD.write(",'%.2f' %f, '%.2f' -%f" %(fytic,fytic,fytic,fytic))
        fytic += yticUnits[i]
    fCMD.write(")\n")
    fCMD.write("set bars 0.5\n")
    fCMD.write("set title '%s' font 'GillSansMT,16'\n" % diseaseNames[i])
#    fCMD.write("plot '%s/%s.%s.whist' using 3:4 with boxes lt 1 lc rgbcolor 'red' title 'Case', '' using 3:(0-$5) with boxes lt 1 lc rgbcolor 'blue' title 'Control', '' using 3:6 with linespoints lt 1 pt 7 ps 0.5 lc rgbcolor 'black' notitle, '%s/%s.%s.whist' using 3:(0-$7) with linespoints lt 1 pt 7 ps 0.5 lc rgbcolor 'black' notitle, '%s/%s.%s.whist' using 3:10:11 with errorbars lt 1 pt 1 lc rgbcolor '#666666' notitle, '%s/%s.%s.whist' using 3:(0-$12):(0-$13) with errorbars lt 1 pt 1 lc rgbcolor '#666666' notitle\n" % (drst,iprefix,diseaseNames[i],drst,iprefix,diseaseNames[i],drst,iprefix,diseaseNames[i],drst,iprefix,diseaseNames[i]) )
    fCMD.write("plot '%s/%s.%s.whist' using 3:4 with boxes lt 1 lc rgbcolor 'red' title 'With disease', '' using 3:(0-$5) with boxes lt 1 lc rgbcolor 'blue' title 'Without disease', '' using 3:10:11 with errorbars lt 1 pt 1 lc rgbcolor '#333333' notitle, '' using 3:(0-$12):(0-$13) with errorbars lt 1 pt 1 lc rgbcolor '#333333' notitle\n" % (drst,iprefix,diseaseNames[i]) )
fCMD.close()
os.system("/home/hmkang/bin/gnuplot %s/%s_whist.cmd" % (dtmp,oprefix))
os.system("/home/hmkang/bin/epstopdf %s/%s_whist.eps" % (drst,oprefix))
#os.system("rm %s/%s_whist.eps" % (drst,oprefix))

fCMD = open("%s/%s_roc.cmd" % (dtmp,oprefix),'w')
fCMD.write("set terminal postscript eps enhanced color linewidth 1.0 size 3.6,3.6 font 'Calibri,12' fontfile 'calibri.pfb' fontfile 'GillSansMT.pfb'\n")
fCMD.write("set out '%s/%s_roc.eps'\n" % (drst,oprefix))
fCMD.write("set multiplot layout 2,2\n")
fCMD.write("set object 1 rect from graph 0, graph 0 to graph 1, graph 1 behind\n");
fCMD.write("set object 1 rect fc rgb '#DDDDDD' fillstyle solid 1.0\n");
fCMD.write("set key below width -5 samplen 1 box\n")
fCMD.write("set xlabel 'Fraction without disease'\n");
fCMD.write("set ylabel 'Fraction with disease' offset 1\n");
fCMD.write("set style fill solid border -1\n")
fCMD.write("set xrange [0:1]\n");
fCMD.write("set yrange [0:1]\n");
fCMD.write("set xtics nomirror out\n");
fCMD.write("set ytics nomirror out\n");
fCMD.write("set grid x y\n");
fCMD.write("set style fill solid noborder\n")
for i in range(len(diseaseNames)):
    fCMD.write("set title '%s' font 'GillSansMT,16'\n" % diseaseNames[i])
#    fCMD.write("set title 'Case-control ROC - %s'\n" % diseaseNames[i])
    fCMD.write("plot '%s/%s.%s.roc' using 1:7:8 with filledcu lc rgbcolor 'green' title 'Sampled AUC = %.3f +- %.3f', '%s/%s.%s.roc' using 1:2 with lines lw 3 lt 1 lc rgbcolor 'red' title 'Expected AUC = %.3f', '%s/%s.%s.roc' using 1:3 with lines lw 3 lt 1 lc rgbcolor 'blue' title 'Very pessimistic AUC = %.3f', '%s/%s.%s.roc' using 1:4 with lines lw 3 lt 1 lc rgbcolor 'blue' title 'Very optimistic AUC = %.3f', x lt 1 lc rgbcolor 'gray' notitle'\n" % (drst,iprefix,diseaseNames[i],AUC_means[i], AUC_ses[i], drst,iprefix,diseaseNames[i],AUC_eORs[i],drst,iprefix,diseaseNames[i],AUC_lowers[i],drst,iprefix,diseaseNames[i],AUC_uppers[i]))
fCMD.close()
os.system("gnuplot %s/%s_roc.cmd" % (dtmp,oprefix))
os.system("epstopdf %s/%s_roc.eps" % (drst,oprefix))
#os.system("rm %s/%s_roc.eps" % (drst,oprefix))

fCMD = open("%s/%s_preval.cmd" % (dtmp,oprefix),'w')
fCMD.write("set terminal postscript eps enhanced color linewidth 1.0 size 3.6,3.6 font 'Calibri,12' fontfile 'calibri.pfb' fontfile 'GillSansMT.pfb'\n")
fCMD.write("set out '%s/%s_preval.eps'\n" % (drst,oprefix))
fCMD.write("set multiplot layout 2,2\n")
fCMD.write("set object 1 rect from graph 0, graph 0 to graph 1, graph 1 behind\n");
fCMD.write("set object 1 rect fc rgb '#DDDDDD' fillstyle solid 1.0\n");
fCMD.write("set key below box\n")
fCMD.write("set xlabel 'Targetted population'\n");
fCMD.write("set ylabel 'Fraction of cases' offset 1\n");
fCMD.write("set style fill solid border -1\n")
fCMD.write("set xrange [1e-3:1]\n");
fCMD.write("set yrange [1e-3:1]\n");
fCMD.write("set logscale xy\n");
fCMD.write("set xtics nomirror out\n");
fCMD.write("set ytics nomirror out\n");
fCMD.write("set grid x y\n");
fCMD.write("set style fill solid noborder\n")
for i in range(len(diseaseNames)):
    fCMD.write("set title '%s' font 'GillSansMT,16'\n" % diseaseNames[i])
#    fCMD.write("set title 'Disease prevalence - %s'\n" % diseaseNames[i])
    preval = 0.03
    fCMD.write("plot '%s/%s.%s.roc' using ($1*%f+$2*%f):($2*%f/($1*%f+$2*%f)) with linespoints lc rgbcolor 'blue' title '%s'\n" % (drst, iprefix, diseaseNames[i], 1.-preval, preval, preval, 1.-preval, preval, diseaseNames[i]))
fCMD.close()
os.system("gnuplot %s/%s_preval.cmd" % (dtmp,oprefix))
os.system("epstopdf %s/%s_preval.eps" % (drst,oprefix))
#os.system("rm %s/%s_preval.eps" % (drst,oprefix))
