#!/usr/bin/python

import os,sys

diseaseNames = ["T2D","AMD","T1D","MI"]
postfixes = ["target"]
a2t = 0.1

drst = "results"
dtmp = "tmp"
prefix = "CTE.a"

standardSampleSizes = []
standardCosts = []
standardTimes = []

for i in range(len(diseaseNames)):
    filename = "%s/%s.%s.%s" % (drst,prefix,diseaseNames[i],postfixes[0])
    fin = open(filename)
    fin.readline()
    items = fin.readline().split()
    fin.close()
    standardSampleSizes.append(items[4])
    standardCosts.append(items[7])
    standardTimes.append(items[9])

fCMD = open("%s/%s_numcost.cmd" % (dtmp,prefix), 'w')
fCMD.write("set terminal postscript eps enhanced color linewidth 1.0 size 3.6,3.6 font 'Calibri,12' fontfile 'calibri.pfb' fontfile 'GillSansMT.pfb'\n")
#fCMD.write("set terminal postscript eps enhanced color linewidth 1.0 size 3.6,3 font 'Calibri,12' fontfile 'calibri.pfb' fontfile 'GillSansMT.pfb'\n")
fCMD.write("set out '%s/%s_numcost.eps'\n" % (drst,prefix))
fCMD.write("set multiplot layout 2,2\n")
#fCMD.write("set lmargin 8\n");
#fCMD.write("set rmargin 8\n");
fCMD.write("set object 1 rect from graph 0, graph 0 to graph 1, graph 1 behind\n");
fCMD.write("set object 1 rect fc rgb '#DDDDDD' fillstyle solid 1.0\n");
fCMD.write("set key below width -10 samplen 2 box\n")
#fCMD.write("unset key\n")
fCMD.write("set xtics nomirror out rotate\n")
fCMD.write("set ytics nomirror out\n")
fCMD.write("set y2tics nomirror out\n")
fCMD.write("set xlabel 'Targeted proportion' offset 0,1.2\n")
fCMD.write("set ylabel '# samples (solid)' offset 2\n")
fCMD.write("set grid x y\n");
fCMD.write("set y2label 'cost in M$ (dashed)' offset -1.5\n")
for i in range(len(diseaseNames)):
    filename = "%s/%s.%s.%s" % (drst,prefix,diseaseNames[i],postfixes[0])
    fCMD.write("set yrange [0:%f]\n" % (float(standardSampleSizes[i])*2))
    fCMD.write("set y2range [0:%f]\n" % (float(standardCosts[i])*2/1e6))
    fCMD.write("set title '%s' font 'GillSansMT,16'\n" % (diseaseNames[i]))
    #fCMD.write("plot '%s' using 1:5 with lines lt 1 lw 3 lc rgbcolor 'red' title 'Conventional trial # samples and cost', '%s' using 1:4 with lines lt 1 lw 3 lc rgbcolor 'blue' title '# on-trial samples', '%s' using 1:($4/$1) with lines lt 1 lw 3 lc rgbcolor '#006600' title '# screened samples', '%s' using 1:($6/1e6) axis x1y2 with lines lt 2 lw 3 lc rgbcolor '#660066' title 'Genetic enrichment trial cost'\n" % (filename,filename,filename,filename))
    fCMD.write("plot '%s' using 1:5 with lines lt 1 lw 3 lc rgbcolor 'red' title '# randomized - conventional trial', '%s' using 1:4 with lines lt 1 lw 3 lc rgbcolor 'blue' title '# randomized - enrichment trial', '%s' using 1:($4/$1) with lines lt 1 lw 3 lc rgbcolor '#006600' title '# screened - enrichment trial', NaN with lines lt 1 lw 3 lc rgbcolor 'red' title 'Total conventional trial cost', '%s' using 1:($6/1e6) axis x1y2 with lines lt 2 lw 3 lc rgbcolor '#660066' title 'Total enrichment trial cost'\n" % (filename,filename,filename,filename))
    #fCMD.write("plot '%s' using 1:5 with lines lt 1 lw 3 lc rgbcolor 'red' title 'Standard trial', '%s' using 1:4 with lines lt 1 lw 3 lc rgbcolor 'blue' title '# follow-up samples', '%s' using 1:($7/1e6) axis x1y2 with lines lt 2 lw 3 lc rgbcolor 'orange' title 'Pooled trial cost'\n" % (filename,filename,filename))
fCMD.close()
os.system("gnuplot %s/%s_numcost.cmd" % (dtmp,prefix))
os.system("epstopdf %s/%s_numcost.eps" % (drst,prefix))
#os.system("rm %s/%s_numcost.eps" % (drst,prefix))

fCMD = open("%s/%s_incidence.cmd" % (dtmp,prefix), 'w')
fCMD.write("set terminal postscript eps enhanced color linewidth 1.0 size 3.6,3.6 font 'Calibri,12' fontfile 'calibri.pfb' fontfile 'GillSansMT.pfb'\n")
fCMD.write("set out '%s/%s_incidence.eps'\n" % (drst,prefix))
fCMD.write("set multiplot layout 2,2\n")
fCMD.write("set object 1 rect from graph 0, graph 0 to graph 1, graph 1 behind\n");
fCMD.write("set object 1 rect fc rgb '#DDDDDD' fillstyle solid 1.0\n");
fCMD.write("set key below box\n")
fCMD.write("set xtics nomirror out\n")
fCMD.write("set ytics nomirror out\n")
fCMD.write("set grid x y\n");
fCMD.write("set xlabel '% Targeted' offset 0,0.2\n")
fCMD.write("set ylabel '% Disease Progression' offset 2\n")
for i in range(len(diseaseNames)):
    filename = "%s/%s.%s.%s" % (drst,prefix,diseaseNames[i],postfixes[0])
    fCMD.write("set yrange [0:100]\n")
    fCMD.write("set xrange [0:100]\n")
    fCMD.write("set title '%s' font 'GillSansMT,16'\n" % (diseaseNames[i]))
#    fCMD.write("set title 'Incidence of targeted group - %s'\n" % (diseaseNames[i]))
    fCMD.write("plot '%s' using ($1*100):($2*100) with lines lt 1 lw 3 lc rgbcolor 'red' title 'Placebo (Ctrl)', '%s' using ($1*100):($3*100) with lines lt 1 lw 3 lc rgbcolor 'blue' title 'Treatment (Rx)', '%s' using ($1*100):(($2-$3)*100) with lines lt 2 lw 3 lc rgbcolor '#006600' title '[Ctrl] - [Rx]'\n" % (filename,filename,filename))
#, '%s' using 1:($3/$2) with lines lt 3 lw 3 lc rgbcolor 'orange' title '[Rx/Ctrl]'\n" % (filename,filename,filename,filename))
fCMD.close()
os.system("gnuplot %s/%s_incidence.cmd" % (dtmp,prefix))
os.system("epstopdf %s/%s_incidence.eps" % (drst,prefix))
#os.system("rm %s/%s_incidence.eps" % (drst,prefix))
