## run CTE

source('CTE.R')

diseaseNames <- c("AMD","T2D")
AUCs.c <- c(0.637,0.750)
AUCs.cg <- c(0.743,0.760)

## set initial parameters
num.geno.samples <- 1e5
num.beta.samples <- 100
num.hist.breaks <- 25
num.frac.targeted <- 1000

i <- 0
for(d in diseaseNames) {
  i <- i+1
  prefix = paste("results/CTE.e",d,sep=".",collapse="")
  print(d);
  params <- InitParams(d)
  params$preval <- params$pi.c

  print( system.time (GeneralRiskEnrichmentTrial(params, AUCs.c[i], paste(c(prefix,"c"),collapse=".") ,num.geno.samples,num.frac.targeted) ) )
  print( system.time (GeneralRiskEnrichmentTrial(params, AUCs.cg[i], paste(c(prefix,"cg"),collapse=".") ,num.geno.samples,num.frac.targeted) ) )  
}
